/*************************************************************************
 Alumno: MOR.
 Fichero: Chat
 *************************************************************************/
#include <conio.h>
#include "transpor.h"
#include "chat.h"

#define TIPO 0x62


void enviar_conversacion (char *mensaje);
void v_arriba(char *datos, char ident[10]);
void v_lado();
void v_abajo(char tecla);
void v_normal(void);
void v_nick(void);
void conectar_chat(void);
void desconectar_chat(void);
void conversacion (void);
void pinta_usuarios(void);



char nick[10];
int pos_buf = 0;
char buf[500];
int va_y=1,
	vl_y = 1,
	vab_x,
	vab_y;




/************************************************************************
/
/************************************************************************/
int Inicializar(void) {
struct REGPACK reg;
int handle,
	i;

  tipo = (char *)malloc(TAM_TIPO);
  memset(tipo, TIPO, TAM_TIPO);

  if (driver_info(&reg) == -1)
	 error(&reg);

  handle = access_type(HI(reg.r_cx), reg.r_dx, LO(reg.r_cx),
					  tipo, TAM_TIPO, (void interrupt *)receiver, &reg);
  if (handle == -1)
	  error(&reg);

  if (get_address (handle, dir_origen, TAM_DIR, &reg) == -1)
	  error(&reg);

  // handle, mode
  if (set_rcv_mode(handle, 3, &reg) == -1)
	 error(&reg);

  // Inicializamos el buffer de entrada de paquetes a vaco
  for (i = 0; i < NUM_MAX_TRAMAS; i++)
	 buffer_entr [i].libre = 1;

  for (i = 0; i < TAM_HASH; i++)
	 red [i] = NULL;

   va_y = 1;
   v_normal();
   v_nick();
   v_normal();

   textbackground(WHITE);
   window(1,1,62,18);
   clrscr();

   anadir_maquina ("__bcast", BROAD_CAST);
   anadir_maquina (nick, dir_origen);

   v_lado();
   v_abajo ('\r');

  return (handle);
}



/************************************************************************
/
/************************************************************************/
void v_arriba(char *datos, char ident[10]){

 textbackground(WHITE);
 window(1,1,62,18);

 gotoxy  (1, va_y);
 textcolor(BLUE);
 cprintf (ident);
 textcolor (WHITE);
 cprintf (" => ");
 cprintf ("%s", datos);
 cprintf ("\n");
 va_y = wherey();

 textbackground(BLUE);
 window(1,20,62,25);
 gotoxy (vab_x, vab_y);
}


/************************************************************************
/
/************************************************************************/
void v_abajo (char tecla){

   if (tecla == '\r') {
	  textbackground(BLUE);
	  window(1,20,62,25);
	  clrscr ();
	  cprintf(nick);
	  cprintf("=>");
	  gotoxy(strlen(nick) + 4,1);
   } else {
	  textbackground(BLUE);
	  window(1,20,62,25);
	  gotoxy (vab_x, vab_y);
	  cprintf("%c", tecla);
   }
   vab_x = wherex();
   vab_y = wherey();
}


/************************************************************************
/
/************************************************************************/
void v_lado (){

 int i,
	 num_usuarios;
 t_maquina *aux_maq;

 textbackground(MAGENTA);
 window(64,1,78,25);

 clrscr();
 clrscr();
 gotoxy(3,1);
 cprintf("Usuarios\n");
 gotoxy(1,2);
 cprintf("---------------");

 num_usuarios = 0;
 for (i = 0; i < TAM_HASH; i++){
	aux_maq = red [i];
	while (aux_maq != NULL) {
	  if (strcmp (aux_maq->logico, "__bcast")) {
		 gotoxy (2, 3 + num_usuarios);
		 cprintf ("%s", aux_maq->logico);
		 num_usuarios++;
	  }
	  aux_maq = aux_maq->siguiente;
	}
 }

 textbackground(BLUE);
 window(1,20,62,25);
 gotoxy (vab_x, vab_y);
}


/************************************************************************
/
/************************************************************************/
void v_normal () {

   textbackground(BLACK);
   window(1,1,80,25);
   clrscr();
}


/************************************************************************
/
/************************************************************************/
void v_nick(){

 char basura [5];

 textcolor(WHITE);
 textbackground(RED);
 window(25,10, 55, 14);
 clrscr();
 gotoxy(3,2);
 cprintf("Nick de usuario: ");
 scanf("%s", nick);
 while (kbhit())
	getch();
}



/************************************************************************
/
/************************************************************************/
t_datagrama enviar_paquete_mensaje (char *dir_logica_dest, char *mensaje,
							 int tam_mensaje, int flag, int num_cliente){

	t_datagrama datagrama;

	strcpy (datagrama.logico_og, nick);
	strcpy (datagrama.logico_dt, dir_logica_dest);
	datagrama.flags = flag;
	datagrama.pq_total = 1;
	datagrama.num_pq = 1;
	datagrama.tam_dat = tam_mensaje;
	datagrama.aux1 = num_cliente;
	enviar_paq (datagrama, mensaje);
	return (datagrama);
}



/************************************************************************
/
/************************************************************************/
void conectar_chat(void) {

   enviar_paquete_mensaje ("__bcast", "", 0, CONECTAR, 0);
}


/************************************************************************
/
/************************************************************************/
void desconectar_chat(void) {

 int i;
 t_maquina *aux_maq;

 for (i = 0; i < TAM_HASH; i++) {
	aux_maq = red [i];
	while (aux_maq != NULL) {
	  if (strcmp (aux_maq->logico, "__bcast"))
		 enviar_paquete_mensaje (aux_maq->logico, "", 0, DESCONECTAR, 0);
	  aux_maq = aux_maq->siguiente;
	}
 }
}



/************************************************************************
/
/************************************************************************/
void conversacion (void) {

   t_paquete paq_rec;
   int hay_paq,
	   aux;


	hay_paq = sacar_paq (&paq_rec);
	if (!hay_paq)
	  return;

	if (paq_rec.datag.flags == CONECTAR) {
	   aux = comprueba_maquina (paq_rec.datag.logico_og, paq_rec.dir_fis_orig, 1);
	   if ((aux == 1) || (aux == 2))
		  enviar_paquete_mensaje (paq_rec.datag.logico_og, "", 0, R_CONECTAR, 0);
	   v_lado ();
	}
	else
	if (paq_rec.datag.flags == R_CONECTAR) {
	   comprueba_maquina (paq_rec.datag.logico_og, paq_rec.dir_fis_orig, 1);
	   v_lado ();
	}
	else
	if (paq_rec.datag.flags == DESCONECTAR) {
		elimina_maquina (paq_rec.datag.logico_og);
		v_lado ();
	}
	else
	if (paq_rec.datag.flags == HABLANDO) {
	   v_arriba (paq_rec.datos, paq_rec.datag.logico_og);
	}
}



/************************************************************************
/
/************************************************************************/
void liberar_handle (int handle) {

	struct REGPACK reg;

	release (handle, &reg);
}



/************************************************************************
/
/************************************************************************/
void enviar_conversacion (char *mensaje) {

   t_maquina *aux_maq;
   int i;

   for (i = 0; i < TAM_HASH; i++) {
	  aux_maq = red [i];
	  while (aux_maq != NULL) {
		if (strcmp (aux_maq->logico, "__bcast"))
		   enviar_paquete_mensaje (aux_maq->logico, mensaje,
								   strlen(mensaje) + 1, HABLANDO, 0);
		aux_maq = aux_maq->siguiente;
	  }
   }
}



/************************************************************************
/
/************************************************************************/
void chequear_tecla (char tecla) {
	 if (tecla == '\b') {
		if (pos_buf > 0) {
		   pos_buf--;
		   v_abajo(tecla);
		}
	 } else {
		buf[pos_buf] = tecla;
		pos_buf++;
		v_abajo(tecla);
	 }
	 if ((tecla == '\r') && (pos_buf > 0)) {
	   buf [pos_buf-1] = '\0';
	   v_arriba (buf, nick);
	   enviar_conversacion (buf);
	   pos_buf = 0;
	 }
}



/************************************************************************
/
/************************************************************************/
int main() {

 char tecla = ' ';
 int salir,
	 handle;

 handle = Inicializar();
 conectar_chat ();
 while ((int)tecla != ESCAPE){
   if (kbhit()){
	 tecla = getch();
	 chequear_tecla (tecla);
   }
   conversacion();
 }
 desconectar_chat();
 v_normal();
 liberar_handle (handle);
 return (0);
}




